# IPolymesh Struct Reference
[External Interfaces]

Inheritance diagram for IPolymesh:

List of all members.

## Public Member Functions
virtual void MCCOMAPI | SetSelection (boolean selected)=0
virtual boolean MCCOMAPI | GetSelection ()=0
virtual boolean MCCOMAPI | GetPartialSelection ()=0
virtual boolean MCCOMAPI | HasSelectedPolygon (boolean useSymmetry=false)=0
virtual boolean MCCOMAPI | HasSelectedEdge ()=0
virtual boolean MCCOMAPI | GetSelectedPolygonsIndex (TMCArray< int32 > &selectionsIndexes)=0
virtual boolean MCCOMAPI | GetSelectedEdgesIndex (TMCArray< int32 > &selectionsIndexes)=0
virtual int32 MCCOMAPI | GetNbVertices ()=0
virtual I3DExVertex *MCCOMAPI | GetVertexNoAddRef (int32 index)=0
virtual void MCCOMAPI | GetVertices (TMCPtrArray< I3DExVertex > &outVertices)=0
| Fills an array with the list of all the vertices of the polymesh.
virtual void MCCOMAPI | ForAllVertices (IVertexCallback *callback)=0
virtual void MCCOMAPI | ForAllPolygons (IPolygonCallback *callback)=0
virtual int32 MCCOMAPI | GetNbEdges () const =0
virtual IEdge *MCCOMAPI | GetEdgeNoAddRef (int32 index)=0
virtual void MCCOMAPI | GetEdges (TMCPtrArray< IEdge > &outEdges)=0
| Fills an array with the list of all the edges of the polymesh.
virtual int32 MCCOMAPI | GetNbPolygons ()=0
virtual IPolygon *MCCOMAPI | GetPolygonNoAddRef (int32 index)=0
virtual void MCCOMAPI | GetPolygons (TMCPtrArray< IPolygon > &outPolygons)=0
| Fills an array with the list of all the polygons of the polymesh.
virtual void MCCOMAPI | CreateVertex (I3DExVertex **vertexPtr, const TVector3 &position)=0
virtual void MCCOMAPI | CreateOrFindVertex (I3DExVertex **vertexPtr, const TVector3 &position)=0
virtual ErrorCode MCCOMAPI | FillPolygons (boolean useSymmetry)=0
virtual void MCCOMAPI | Delete ()=0
virtual void MCCOMAPI | DeleteSelectedEdges ()=0
virtual void MCCOMAPI | DeleteSelectedVertices (boolean useSymmetry)=0
virtual void MCCOMAPI | DeleteSelectedPolygons (boolean useSymmetry)=0
virtual boolean MCCOMAPI | GetBoundingBox (TBBox3D &bbox, boolean selection, boolean includeSymSelection=false, boolean ignoreSkinning=true)=0
virtual boolean MCCOMAPI | GetUVBoundingBox (TBBox2D &bbox, boolean selection=false)=0
virtual void MCCOMAPI | Triangulate ()=0
virtual ErrorCode MCCOMAPI | GetPolylineHeads (TMCPtrArray< I3DExVertex > &vertices, TMCArray< boolean > &AreClosed, boolean useSymmetry)=0
virtual void MCCOMAPI | Clone (IPolymesh **)=0
virtual boolean MCCOMAPI | Weld (real tolerance, boolean alignOnly)=0
virtual void MCCOMAPI | Merge (IPolymesh *polymesh)=0
virtual void MCCOMAPI | InvertNormals ()=0
virtual void MCCOMAPI | FlipCheck (boolean force)=0
virtual void MCCOMAPI | EnableFlipCheck (boolean value, boolean checkNow=true)=0
virtual boolean MCCOMAPI | IsPolymeshManifold ()=0
virtual IPolygon *MCCOMAPI | MakePolygon (const TMCClassArray< TVMIVertexPtr > &vertices)=0
virtual IPolygon *MCCOMAPI | MakePolygonCarefully (const TMCClassArray< TVMIVertexPtr > &ivertices)=0
virtual IPolygon *MCCOMAPI | MakePolygonByForce (const TMCClassArray< TVMIVertexPtr > &ivertices)=0
virtual TVMIVertexPtr MCCOMAPI | ImportVertex (const TVertex3D &vertex3d, boolean useUV, int32 index)=0
virtual void MCCOMAPI | Topology (int32 counts[kNumberOfCases])=0
virtual void MCCOMAPI | StartEdgeTransfer ()=0
virtual int32 MCCOMAPI | EdgeTransfer (EdgeData edgeBuffer[], int32 bufferSize)=0
virtual void MCCOMAPI | ConsistencyCheck ()=0
virtual void MCCOMAPI | PreBoolean ()=0
virtual void MCCOMAPI | Split (IPolymesh *polymesh)=0
virtual void MCCOMAPI | GetName (char *name)=0
virtual void MCCOMAPI | SetName (char *name)=0
virtual void MCCOMAPI | SetUVPlaneAxis (int32 shadeAxis, int32 spaceAxis, boolean positive)=0
virtual int32 MCCOMAPI | GetUVPlaneAxis (int32 shadeAxis)=0
virtual real MCCOMAPI | GetUVValue (int32 shadeAxis)=0
virtual boolean MCCOMAPI | GetUVPlanePositive (int32 shadeAxis)=0
virtual void MCCOMAPI | SetUVCustomMode (int32 axis, int32 mode, boolean onSelection)=0
virtual int32 MCCOMAPI | GetUVCustomMode (int32 axis)=0
virtual void MCCOMAPI | SetUVMode (EUVMappingModes mode)=0
virtual EUVMappingModes MCCOMAPI | GetUVMode ()=0
virtual void MCCOMAPI | GetUVWraparound (boolean &outWrapU, boolean &outWrapV)=0
virtual void MCCOMAPI | SetUVWraparound (const boolean inWrapU, const boolean inWrapV)=0
virtual void MCCOMAPI | SetUVAxisMode (int32 mode)=0
virtual int32 MCCOMAPI | GetUVAxisMode ()=0
virtual void MCCOMAPI | SetUVAxis (real roll, real pitch, real yaw)=0
virtual void MCCOMAPI | GetUVAxis (real &roll, real &pitch, real &yaw)=0
virtual void MCCOMAPI | BoxProjection (boolean onSelection, TBoxProjectionData &data)=0
virtual void MCCOMAPI | SphereProjection (boolean onSelection, TSphereProjectionData &data)=0
virtual void MCCOMAPI | CylinderProjection (boolean onSelection, TSphereProjectionData &data)=0
virtual void MCCOMAPI | PlanarProjection (boolean onSelection, TPlanarProjectionData &data)=0
virtual void MCCOMAPI | SetMarker (int32 iD)=0
virtual int32 MCCOMAPI | GetMarker ()=0
virtual void MCCOMAPI | GetVertexIndexList (I3DExVertex *v, TMCArray< int32 > &Index)=0
virtual void MCCOMAPI | FlushOptimizer (void)=0
virtual void MCCOMAPI | Transform (const TTransform3D &trans)=0
virtual void MCCOMAPI | InvertSelection (int32 selectionFlag)=0
virtual void MCCOMAPI | SetVerticesHidden (boolean hidden)=0
virtual void MCCOMAPI | SetSymmetricModelingEnabled (boolean enable)=0
virtual boolean MCCOMAPI | GetIsSymmetricModelingEnabled ()=0
virtual void MCCOMAPI | SetSymmetryPlane (const TVector3 &axis, const TVector3 &center)=0
virtual void MCCOMAPI | GetSymmetryPlane (TVector3 &axis, TVector3 &center)=0
virtual void MCCOMAPI | SetSubdivisionType (ESubdivisionType type)=0
virtual ESubdivisionType MCCOMAPI | GetSubdivisionType ()=0
virtual void MCCOMAPI | SetSubdivisionLevel (int32 level, boolean renderingMesh)=0
virtual int32 MCCOMAPI | GetSubdivisionLevel (boolean renderingMesh)=0
virtual void MCCOMAPI | ConvertSubdivisionToPolygons (IPolymesh **iPolymesh)=0
virtual void MCCOMAPI | GetPolyMeshFacetMesh (FacetMesh **outMesh)=0
virtual void MCCOMAPI | Resize (TVector3 &scale, TVector3 &center, boolean useSymmetry)=0
virtual boolean MCCOMAPI | GetPolymeshVisibility () const =0
virtual void MCCOMAPI | SetPolymeshVisibility (boolean visible)=0
virtual IMorphAreaData *MCCOMAPI | GetMorphAreaData (int32 morphAreaIndex)=0
virtual void MCCOMAPI | ApplyDisplacementBrush (const TDisplacementBrushParam &displacementParam, TDisplacementBrushContext &context)=0
virtual void MCCOMAPI | BuildDisplacementMaps (TMCCountedPtrArray< IShRasterLayer > &rasterLayers, const TDisplacementExportParameters &exportParameters)=0
virtual void MCCOMAPI | CleanDisplacementAlpha ()=0
virtual void MCCOMAPI | UpdateDisplacementBetweenLevels (int32 minLevel, int32 maxLevel)=0
virtual void MCCOMAPI | SwapDisplacementMap (int32 subdivisionLevel, TMCCopyOnWritePtr< TDisplacementMap > &displacementMap)=0
virtual void MCCOMAPI | GetDisplacementMap (int32 subdivisionLevel, TMCCopyOnWritePtr< TDisplacementMap > &displacementMap)=0
virtual void MCCOMAPI | SetDisplacementMap (int32 subdivisionLevel, const TMCCopyOnWritePtr< TDisplacementMap > &displacementMap)=0
virtual boolean MCCOMAPI | HasDisplacement ()=0
virtual int32 MCCOMAPI | GetLastDisplacementLevelModified ()=0
virtual void MCCOMAPI | SetLastDisplacementLevelModified (int32 level)=0
virtual void MCCOMAPI | StoreNormalsForRayHit ()=0
virtual void MCCOMAPI | DeleteStoredNormals ()=0
virtual boolean MCCOMAPI | HasSelectedParts ()=0
virtual void MCCOMAPI | FinishDisplacement ()=0
virtual void MCCOMAPI | ClearSelectionCache ()=0
virtual boolean MCCOMAPI | GetSubdivisionUVMode ()=0
virtual void MCCOMAPI | SetSubdivisionUVMode (boolean subUVMode)=0
virtual void MCCOMAPI | SetDisplacementMode (boolean enableDisp)=0
virtual boolean MCCOMAPI | GetDisplacementMode ()=0
virtual void MCCOMAPI | DeleteDisplacement ()=0
virtual void MCCOMAPI | CleanDisplacementMap ()=0
virtual void MCCOMAPI | GetPositionsBeforeDisplacementMap (TMCCopyOnWritePtr< TDisplacementMap > &originalPositions)=0
virtual void MCCOMAPI | SwapPositionsBeforeDisplacementMap (TMCCopyOnWritePtr< TDisplacementMap > &originalPositions)=0
virtual void MCCOMAPI | SwapPositionsForMorphEdition (boolean isEditing)=0
virtual void MCCOMAPI | FlipCheckIfSuccessful (boolean force)=0
virtual void MCCOMAPI | ApplyWeightBrush (const TWeightBrushParam &weightParam)=0
virtual void MCCOMAPI | GetUVModelerData (TSegmentMesh &segmentMesh, TPointMesh &pointMesh, int32 shadingDomain, TSplitHandles *splitHandles, TMCColorRGBA8 &meshBaseColor)=0
virtual void MCCOMAPI | SelectUVPatch (I3DExVertex *vertexInPatch, int32 uvIndex, boolean select)=0
virtual void MCCOMAPI | UpdateUVColorData (TSegmentMesh &segmentMesh, TPointMesh &pointMesh, int32 shadingDomain, TSplitHandles *splitHandles, TMCColorRGBA8 &meshBaseColor)=0
virtual boolean MCCOMAPI | SetUVBoundingBox (const TBBox2D &bbox)=0

## Detailed Description

A Polymesh is a 3D object consisting of vertices with edges and polygons defined on the set of vertices. It can apply various UV mappings to its set of vertices, and it can compute subdivision surfaces using its polygons as the control mesh. For rendering and display, it can output a facet mesh based on its polygons or the subdivision surface.

## Member Function Documentation

virtual void MCCOMAPI IPolymesh::ApplyDisplacementBrush | ( | const TDisplacementBrushParam & | displacementParam,
|  | TDisplacementBrushContext & | context |
| ) |  |  | `[pure virtual]`

Applies a displacement brush to the polymesh.

Parameters:

  | displacementParam | The index of the morph area

virtual void MCCOMAPI IPolymesh::ApplyWeightBrush | ( | const TWeightBrushParam & | weightParam | ) | `[pure virtual]`

Applies a weight brush to the polymesh.

Parameters:

  | weightParam | Holds information about the brush's location.

virtual void MCCOMAPI IPolymesh::BoxProjection | ( | boolean | onSelection,
|  | TBoxProjectionData & | data |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::BuildDisplacementMaps | ( | TMCCountedPtrArray< IShRasterLayer > & | rasterLayers,
|  | const TDisplacementExportParameters & | exportParameters |
| ) |  |  | `[pure virtual]`

Fills the displacement maps associated with a given model

Parameters:

  | rasterLayers | The maps to fill
  | exportParameters | The parameters to control the creation of the maps

virtual void MCCOMAPI IPolymesh::CleanDisplacementAlpha | ( |  | ) | `[pure virtual]`

Clean the alpha map for this particular polymesh.

virtual void MCCOMAPI IPolymesh::CleanDisplacementMap | ( |  | ) | `[pure virtual]`

Clean original position and displacement maps. Original positions will become actual positions (displaced or not)

virtual void MCCOMAPI IPolymesh::ClearSelectionCache | ( |  | ) | `[pure virtual]`

Clean the Selection Cache build for displacement

virtual void MCCOMAPI IPolymesh::Clone | ( | IPolymesh ** |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::ConsistencyCheck | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::ConvertSubdivisionToPolygons | ( | IPolymesh ** | iPolymesh | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::CreateOrFindVertex | ( | I3DExVertex ** | vertexPtr,
|  | const TVector3 & | position |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::CreateVertex | ( | I3DExVertex ** | vertexPtr,
|  | const TVector3 & | position |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::CylinderProjection | ( | boolean | onSelection,
|  | TSphereProjectionData & | data |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::Delete | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::DeleteDisplacement | ( |  | ) | `[pure virtual]`

Swap to original positions and delete actual displacement

virtual void MCCOMAPI IPolymesh::DeleteSelectedEdges | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::DeleteSelectedPolygons | ( | boolean | useSymmetry | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::DeleteSelectedVertices | ( | boolean | useSymmetry | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::DeleteStoredNormals | ( |  | ) | `[pure virtual]`

Delete the normal stored with StoreNormalsForRayHit

virtual int32 MCCOMAPI IPolymesh::EdgeTransfer | ( | EdgeData | edgeBuffer[],
|  | int32 | bufferSize |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::EnableFlipCheck | ( | boolean | value,
|  | boolean | checkNow = `true` |
| ) |  |  | `[pure virtual]`

virtual ErrorCode MCCOMAPI IPolymesh::FillPolygons | ( | boolean | useSymmetry | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::FinishDisplacement | ( |  | ) | `[pure virtual]`

Clean the structures and unset the flags used for displacement

virtual void MCCOMAPI IPolymesh::FlipCheck | ( | boolean | force | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::FlipCheckIfSuccessful | ( | boolean | force | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::FlushOptimizer | ( | void |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::ForAllPolygons | ( | IPolygonCallback * | callback | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::ForAllVertices | ( | IVertexCallback * | callback | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::GetBoundingBox | ( | TBBox3D & | bbox,
|  | boolean | selection,
|  | boolean | includeSymSelection = `false`,
|  | boolean | ignoreSkinning = `true` |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetDisplacementMap | ( | int32 | subdivisionLevel,
|  | TMCCopyOnWritePtr< TDisplacementMap > & | displacementMap |
| ) |  |  | `[pure virtual]`

Returns the displacement map at a subdivision given level

virtual boolean MCCOMAPI IPolymesh::GetDisplacementMode | ( |  | ) | `[pure virtual]`

Returns true if the displacement applyed on the polymesh is emable

virtual IEdge* MCCOMAPI IPolymesh::GetEdgeNoAddRef | ( | int32 | index | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetEdges | ( | TMCPtrArray< IEdge > & | outEdges | ) | `[pure virtual]`

Fills an array with the list of all the edges of the polymesh.

virtual boolean MCCOMAPI IPolymesh::GetIsSymmetricModelingEnabled | ( |  | ) | `[pure virtual]`

virtual int32 MCCOMAPI IPolymesh::GetLastDisplacementLevelModified | ( |  | ) | `[pure virtual]`

Returns the index of the last displacement levle that was modified. This is used to apply the changes to the lower levels of resolutions.

virtual int32 MCCOMAPI IPolymesh::GetMarker | ( |  | ) | `[pure virtual]`

virtual IMorphAreaData* MCCOMAPI IPolymesh::GetMorphAreaData | ( | int32 | morphAreaIndex | ) | `[pure virtual]`

Returns a pointer to the data for a morph area on a given polymesh

Parameters:

  | morphAreaIndex | The index of the morph area

virtual void MCCOMAPI IPolymesh::GetName | ( | char * | name | ) | `[pure virtual]`

virtual int32 MCCOMAPI IPolymesh::GetNbEdges | ( |  | ) | const`[pure virtual]`

virtual int32 MCCOMAPI IPolymesh::GetNbPolygons | ( |  | ) | `[pure virtual]`

virtual int32 MCCOMAPI IPolymesh::GetNbVertices | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::GetPartialSelection | ( |  | ) | `[pure virtual]`

virtual IPolygon* MCCOMAPI IPolymesh::GetPolygonNoAddRef | ( | int32 | index | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetPolygons | ( | TMCPtrArray< IPolygon > & | outPolygons | ) | `[pure virtual]`

Fills an array with the list of all the polygons of the polymesh.

virtual ErrorCode MCCOMAPI IPolymesh::GetPolylineHeads | ( | TMCPtrArray< I3DExVertex > & | vertices,
|  | TMCArray< boolean > & | AreClosed,
|  | boolean | useSymmetry |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetPolyMeshFacetMesh | ( | FacetMesh ** | outMesh | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::GetPolymeshVisibility | ( |  | ) | const`[pure virtual]`

Returns the visibility of the polymesh. Note that this flag is different compared to the hidden property of the vertices. The flag on the vertices affects only the modeler. This function returns the visibility of the polymesh in the scene (both 3DView and rendering).

virtual void MCCOMAPI IPolymesh::GetPositionsBeforeDisplacementMap | ( | TMCCopyOnWritePtr< TDisplacementMap > & | originalPositions | ) | `[pure virtual]`

Return position before displacement map.

Parameters:

  | originalPositions | position before displacement map.

virtual boolean MCCOMAPI IPolymesh::GetSelectedEdgesIndex | ( | TMCArray< int32 > & | selectionsIndexes | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::GetSelectedPolygonsIndex | ( | TMCArray< int32 > & | selectionsIndexes | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::GetSelection | ( |  | ) | `[pure virtual]`

virtual int32 MCCOMAPI IPolymesh::GetSubdivisionLevel | ( | boolean | renderingMesh | ) | `[pure virtual]`

Returns the current subdivision level applyed on the polymesh

Parameters:

  | renderingMesh | True if we are asking for the rendering mesh

virtual ESubdivisionType MCCOMAPI IPolymesh::GetSubdivisionType | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::GetSubdivisionUVMode | ( |  | ) | `[pure virtual]`

Return the current UV subdivision mode applyed on the polymesh

virtual void MCCOMAPI IPolymesh::GetSymmetryPlane | ( | TVector3 & | axis,
|  | TVector3 & | center |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetUVAxis | ( | real & | roll,
|  | real & | pitch,
|  | real & | yaw |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI IPolymesh::GetUVAxisMode | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::GetUVBoundingBox | ( | TBBox2D & | bbox,
|  | boolean | selection = `false` |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI IPolymesh::GetUVCustomMode | ( | int32 | axis | ) | `[pure virtual]`

virtual EUVMappingModes MCCOMAPI IPolymesh::GetUVMode | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetUVModelerData | ( | TSegmentMesh & | segmentMesh,
|  | TPointMesh & | pointMesh,
|  | int32 | shadingDomain,
|  | TSplitHandles * | splitHandles,
|  | TMCColorRGBA8 & | meshBaseColor |
| ) |  |  | `[pure virtual]`

Get the UV modeler data.

virtual int32 MCCOMAPI IPolymesh::GetUVPlaneAxis | ( | int32 | shadeAxis | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::GetUVPlanePositive | ( | int32 | shadeAxis | ) | `[pure virtual]`

virtual real MCCOMAPI IPolymesh::GetUVValue | ( | int32 | shadeAxis | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetUVWraparound | ( | boolean & | outWrapU,
|  | boolean & | outWrapV |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetVertexIndexList | ( | I3DExVertex * | v,
|  | TMCArray< int32 > & | Index |
| ) |  |  | `[pure virtual]`

virtual I3DExVertex* MCCOMAPI IPolymesh::GetVertexNoAddRef | ( | int32 | index | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::GetVertices | ( | TMCPtrArray< I3DExVertex > & | outVertices | ) | `[pure virtual]`

Fills an array with the list of all the vertices of the polymesh.

virtual boolean MCCOMAPI IPolymesh::HasDisplacement | ( |  | ) | `[pure virtual]`

Return if polymesh has displacement maps

virtual boolean MCCOMAPI IPolymesh::HasSelectedEdge | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::HasSelectedParts | ( |  | ) | `[pure virtual]`

Returns true if some elements of the polymesh are selected

virtual boolean MCCOMAPI IPolymesh::HasSelectedPolygon | ( | boolean | useSymmetry = `false` | ) | `[pure virtual]`

virtual TVMIVertexPtr MCCOMAPI IPolymesh::ImportVertex | ( | const TVertex3D & | vertex3d,
|  | boolean | useUV,
|  | int32 | index |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::InvertNormals | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::InvertSelection | ( | int32 | selectionFlag | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::IsPolymeshManifold | ( |  | ) | `[pure virtual]`

virtual IPolygon* MCCOMAPI IPolymesh::MakePolygon | ( | const TMCClassArray< TVMIVertexPtr > & | vertices | ) | `[pure virtual]`

Creates a new polygon in this Polymesh.

Parameters:

  | vertices | Array of vertices in the new Polygon

Returns:
  A pointer to the new Polygon created

virtual IPolygon* MCCOMAPI IPolymesh::MakePolygonByForce | ( | const TMCClassArray< TVMIVertexPtr > & | ivertices | ) | `[pure virtual]`

Creates a new polygon. MakePolygonByForce inserts the polygon, regardless of whether or not the edges of the polgon already have two polygons, by creating new edges.

Parameters:

  | ivertices | Array of vertices in the new Polygon

Returns:
  A pointer to the new Polygon created

virtual IPolygon* MCCOMAPI IPolymesh::MakePolygonCarefully | ( | const TMCClassArray< TVMIVertexPtr > & | ivertices | ) | `[pure virtual]`

Creates a new polygon. Note that MakePolygonCarefully checks first to make sure that a polygon with these vertices doesn't already exist in the polymesh.

Parameters:

  | ivertices | Array of vertices in the new Polygon

Returns:
  A pointer to the new Polygon created

virtual void MCCOMAPI IPolymesh::Merge | ( | IPolymesh * | polymesh | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::PlanarProjection | ( | boolean | onSelection,
|  | TPlanarProjectionData & | data |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::PreBoolean | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::Resize | ( | TVector3 & | scale,
|  | TVector3 & | center,
|  | boolean | useSymmetry |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SelectUVPatch | ( | I3DExVertex * | vertexInPatch,
|  | int32 | uvIndex,
|  | boolean | select |
| ) |  |  | `[pure virtual]`

Select/UnSelect a UV patch

virtual void MCCOMAPI IPolymesh::SetDisplacementMap | ( | int32 | subdivisionLevel,
|  | const TMCCopyOnWritePtr< TDisplacementMap > & | displacementMap |
| ) |  |  | `[pure virtual]`

Sets the displacement map at a subdivision given level

virtual void MCCOMAPI IPolymesh::SetDisplacementMode | ( | boolean | enableDisp | ) | `[pure virtual]`

Enable/Disable the displacement applyed on the polymesh

Parameters:

  | enableDisp | True if displacement is enable

virtual void MCCOMAPI IPolymesh::SetLastDisplacementLevelModified | ( | int32 | level | ) | `[pure virtual]`

Sets the index of the last displacement levle that was modified. This is used to apply the changes to the lower levels of resolutions.

virtual void MCCOMAPI IPolymesh::SetMarker | ( | int32 | iD | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetName | ( | char * | name | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetPolymeshVisibility | ( | boolean | visible | ) | `[pure virtual]`

Sets the visibility of the polymesh. Note that this flag is different compared to the hidden property of the vertices. The flag on the vertices affects only the modeler. This function sets the visibility of the polymesh in the scene (both 3DView and rendering).

Parameters:

  | visible | The new visibility flag

virtual void MCCOMAPI IPolymesh::SetSelection | ( | boolean | selected | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetSubdivisionLevel | ( | int32 | level,
|  | boolean | renderingMesh |
| ) |  |  | `[pure virtual]`

Determines the level of subdivision applied on the mesh when the subdivision type is different from eSubdivisionNone

Parameters:

  | level | The number of subdivision passes applied on the mesh
  | renderingMesh | True if it is for the rendering mesh (false means modeling mesh)

virtual void MCCOMAPI IPolymesh::SetSubdivisionType | ( | ESubdivisionType | type | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetSubdivisionUVMode | ( | boolean | subUVMode | ) | `[pure virtual]`

Sets the mode of UV subdivision used for this polymesh

Parameters:

  | subUVMode | The mode of UV subdivision applied on the mesh

virtual void MCCOMAPI IPolymesh::SetSymmetricModelingEnabled | ( | boolean | enable | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetSymmetryPlane | ( | const TVector3 & | axis,
|  | const TVector3 & | center |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetUVAxis | ( | real | roll,
|  | real | pitch,
|  | real | yaw |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetUVAxisMode | ( | int32 | mode | ) | `[pure virtual]`

virtual boolean MCCOMAPI IPolymesh::SetUVBoundingBox | ( | const TBBox2D & | bbox | ) | `[pure virtual]`

Set the bounding box of the UVs

virtual void MCCOMAPI IPolymesh::SetUVCustomMode | ( | int32 | axis,
|  | int32 | mode,
|  | boolean | onSelection |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetUVMode | ( | EUVMappingModes | mode | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetUVPlaneAxis | ( | int32 | shadeAxis,
|  | int32 | spaceAxis,
|  | boolean | positive |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetUVWraparound | ( | const boolean | inWrapU,
|  | const boolean | inWrapV |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SetVerticesHidden | ( | boolean | hidden | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::SphereProjection | ( | boolean | onSelection,
|  | TSphereProjectionData & | data |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::Split | ( | IPolymesh * | polymesh | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::StartEdgeTransfer | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::StoreNormalsForRayHit | ( |  | ) | `[pure virtual]`

Stores the normals of the mesh for use in I3DExVertexPrimitive::RayHit().

virtual void MCCOMAPI IPolymesh::SwapDisplacementMap | ( | int32 | subdivisionLevel,
|  | TMCCopyOnWritePtr< TDisplacementMap > & | displacementMap |
| ) |  |  | `[pure virtual]`

Swaps the displacement maps at a subdivision given level

virtual void MCCOMAPI IPolymesh::SwapPositionsBeforeDisplacementMap | ( | TMCCopyOnWritePtr< TDisplacementMap > & | originalPositions | ) | `[pure virtual]`

Swap position before displacement map.

Parameters:

  | originalPositions | position before displacement map.

virtual void MCCOMAPI IPolymesh::SwapPositionsForMorphEdition | ( | boolean | isEditing | ) | `[pure virtual]`

Swap displacement map before or after Moprh edition.

Parameters:

  | isEditing | True if we are in Morph Edition Mode.

virtual void MCCOMAPI IPolymesh::Topology | ( | int32 | counts[kNumberOfCases] | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::Transform | ( | const TTransform3D & | trans | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::Triangulate | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IPolymesh::UpdateDisplacementBetweenLevels | ( | int32 | minLevel,
|  | int32 | maxLevel |
| ) |  |  | `[pure virtual]`

Propagate the changes of the displacement from maxLevel to minLevel

virtual void MCCOMAPI IPolymesh::UpdateUVColorData | ( | TSegmentMesh & | segmentMesh,
|  | TPointMesh & | pointMesh,
|  | int32 | shadingDomain,
|  | TSplitHandles * | splitHandles,
|  | TMCColorRGBA8 & | meshBaseColor |
| ) |  |  | `[pure virtual]`

Get the UV modeler data.

virtual boolean MCCOMAPI IPolymesh::Weld | ( | real | tolerance,
|  | boolean | alignOnly |
| ) |  |  | `[pure virtual]`

The documentation for this struct was generated from the following file:

- IPolymesh.h